package meerkat.bulletinboard.webapp;


import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

import com.google.protobuf.ByteString;

import meerkat.bulletinboard.sqlserver.SQLiteBulletinBoardServer;
import meerkat.comm.CommunicationException;
import meerkat.protobuf.Crypto.*;
import meerkat.protobuf.Voting.*;

@Path("/test")
public class SQLiteServerTest {
	
	@GET
	public Response main(){
		byte[] b1 = {(byte) 1, (byte)2, (byte) 3, (byte) 4};
		byte[] b2 = {(byte) 11, (byte)12, (byte) 13, (byte) 14};
		
		Response response;
		
		BulletinBoardMessage msg;
		try{
			msg = BulletinBoardMessage.newBuilder()
					.setMsg(UnsignedBulletinBoardMessage.newBuilder()
							.addTags("Signature")
							.addTags("Trustee")
							.setData(ByteString.copyFrom(b1))
							.build())
					.setSig(Signature.newBuilder()
							.setType(SignatureType.DSA)
							.setData(ByteString.copyFrom(b2))
							.build())
					.build();
			
			SQLiteBulletinBoardServer bbs = new SQLiteBulletinBoardServer();
		
		
			bbs.init();
			
			bbs.postMessage(msg);
			response = Response.status(Status.OK).entity(bbs.testPrint()).build();
			
			bbs.close();
			
		} catch(CommunicationException e){
			response = Response.status(Status.OK).entity(e.getMessage()).build();;
		}
		
		return response;
	}
	
}
